<template>
	<v-dialog v-model="open" max-width="50em" v-bind="$attrs" :content-class="contentClass">
		<v-card>
			<v-toolbar v-if="title" color="grey lighten-2" flat>
				<v-toolbar-title>{{ title }}</v-toolbar-title>
			</v-toolbar>

			<v-divider />

			<v-alert v-if="!loading && error" type="error" class="ma-4 d-flex justify-center">
				{{ error }}
			</v-alert>

			<v-card-text>
				<slot name="content-header" />
				<div v-if="message || $slots.default" class="d-flex justify-center align-center mt-4 mx-2">
					<template v-if="!hideIcon">
						<v-icon :color="iconColor">{{ icon }}</v-icon>
						<v-divider vertical class="mx-2" />
					</template>
					<div>
						<template v-if="message">
							<p v-for="(paragraph, i) of messages" :key="i" :class="{ 'mt-4': i === 0 }">
								{{ paragraph }}
							</p>
						</template>
						<slot />
					</div>
				</div>
				<slot name="content-footer" />
			</v-card-text>

			<v-divider />

			<v-card-actions class="d-flex flex-wrap justify-end">
				<v-btn text rounded @click="open = false" :disabled="loading" v-if="showCancelButton"> Cancel </v-btn>
				<v-btn
					v-if="button"
					:color="buttonColor"
					text
					rounded
					@click="$emit('confirm')"
					:loading="loading"
					:disabled="buttonDisabled"
				>
					{{ button }}
				</v-btn>
			</v-card-actions>
		</v-card>
	</v-dialog>
</template>

<script lang="ts">
import { computed, defineComponent, watch } from '@vue/composition-api';

export default defineComponent({
	props: {
		value: {
			type: Boolean,
		},
		title: {
			type: String,
		},
		error: {
			type: String,
		},
		loading: {
			type: Boolean,
		},
		icon: {
			type: String,
			default: 'mdi-exclamation-thick',
		},
		iconColor: {
			type: String,
			default: 'warning',
		},
		hideIcon: {
			type: Boolean,
			default: false,
		},
		message: {
			type: [String, Array],
		},
		button: {
			type: String,
		},
		buttonColor: {
			type: String,
			default: 'green',
		},
		buttonDisabled: {
			type: Boolean,
			default: false,
		},
		cleanup: {
			type: String,
		},
		contentClass: {
			type: String,
		},
		showCancelButton: {
			type: Boolean,
			default: true,
		},
	},
	emits: ['confirm', 'cleanup'],
	setup(props, { root, emit }) {
		const open = computed<boolean>({
			get: () => props.value ?? false,
			set: (value: boolean) => emit('input', value),
		});

		const messages = computed(() => (Array.isArray(props.message) ? props.message : [props.message]));

		watch(
			() => [open.value, props.cleanup],
			([value]) => {
				if (!value) {
					if (props.cleanup) {
						root.$store.dispatch(props.cleanup);
					}
					emit('cleanup');
				}
			}
		);

		return {
			open,
			messages,
		};
	},
});
</script>
